#!/bin/sh
HEADLESS=0
WRAPLESS=1
while getopts hw: opt > /dev/null 2>&1; do
  case "$opt" in
  h)  HEADLESS=1
      shift;;
  w)  WRAPLESS=0
      shift;;
  # handle negatives
  \?) if ! echo $1 | awk '{ exit ! /^-[0-9]+$/ }'; then
        echo >&2 "usage: $0 [-hw] [n_RULE [n_THREADS]]"
        exit
      fi
  esac
done
#shift `expr $OPTIND - 1`

#cd Projects/java/life2d
#for i in data*.life; do
#  SIZE=`ls -s $i 2> /dev/null | awk '{print $1;}'`
#  if test "$SIZE" = "0"; then
#    rm -f $i
#  fi
#done
ls -alrt data?*.life 2> /dev/null

MAX=10
THREADS=1
OFFSET=0
if test `hostname | cut -c1` = "z"; then
  THREADS=6
elif test `hostname | cut -c1` = "O"; then
  THREADS=6
elif test `hostname | cut -c1` = "I"; then
  THREADS=3
  OFFSET=4
  if test `hostname | grep X 2> /dev/null`; then
    THREADS=2
    OFFSET=`expr $OFFSET + $MAX / 2`
  fi
fi
if test $# -lt 1; then
  day=`date -u +%s/86400 | bc`
  ruleIndex=`expr $day + $OFFSET`
else
  ruleIndex=$1
  if test $# -ge 2; then
    THREADS=$2
  fi
fi
if test $ruleIndex -ge 0; then
  rand=`expr $ruleIndex % $MAX`
else
  rand=$ruleIndex
fi

COUNT=100; STIRS=1; STATES=2
EDGE=0; UNBOUND=1; BLOB=60
FILL=37
NUMBERED=-1
if test $rand -eq 0; then
  # Bays
  NEIGHBORS=6; RULE=B2/S35; LENGTH=1024; PERIOD=60; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 1; then
  # Andreen
  NEIGHBORS=6; RULE=B2o3o4m/S2om4o; LENGTH=2048; PERIOD=80; WRAP=0; SEARCH=pattern
  #THREADS=1
elif test $rand -eq 2; then
  # Maydwell
  NEIGHBORS=8; RULE=B3/S2ckan3; LENGTH=1024; PERIOD=30; WRAP=0; SEARCH=pattern
elif test $rand -eq 3; then
  # Day and Night
  NEIGHBORS=8; RULE=B3678/S34678; LENGTH=1024; PERIOD=48; WRAP=$WRAPLESS; SEARCH=pattern
  COUNT=32
#  THREADS=1
elif test $rand -eq 4; then
# 60
  NEIGHBORS=9; RULE=B34/S3;LENGTH=1024; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 5; then
  NEIGHBORS=12; RULE=B4/S356; LENGTH=1024; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 6; then
  NEIGHBORS=12; RULE=B45/S23; LENGTH=1024; PERIOD=264; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 7; then
  NEIGHBORS=12; RULE=B456/S23; LENGTH=1024; PERIOD=40; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 8; then
  NEIGHBORS=12; RULE=B456/S45; LENGTH=1024; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq 9; then
  NEIGHBORS=12; RULE=B46/S24; LENGTH=1024; PERIOD=12; WRAP=0; SEARCH=pattern

# Given up on these... but can be accessed directly
elif test $rand -eq -1; then
#  no glider
  NEIGHBORS=5; RULE=B24/S2; LENGTH=1024; PERIOD=168; WRAP=1; SEARCH=glider
elif test $rand -eq -2; then
#  Nothing found in a while
  NEIGHBORS=5; RULE=B2/S24; LENGTH=1024; PERIOD=120; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -3; then
#  no glider, Nothing found in a while
  NEIGHBORS=6; RULE=B2/S34; LENGTH=2048; PERIOD=240; WRAP=1; SEARCH=glider # From Wiki
elif test $rand -eq -4; then
  # Callahan
  NEIGHBORS=6; RULE=B2o/S2m34; LENGTH=1024; PERIOD=120; WRAP=0; SEARCH=pattern
  EDGE=0; UNBOUND=1; BLOB=60
elif test $rand -eq -5; then
  NEIGHBORS=7; RULE=B346/S23; LENGTH=1024; PERIOD=24; WRAP=0; SEARCH=pattern
elif test $rand -eq -6; then
#  Nothing found in a while
  NEIGHBORS=12; RULE=B3/S2; LENGTH=1024; PERIOD=4; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -7; then
#  long to settle and lots of junk
  NEIGHBORS=12; RULE=B3/S23; LENGTH=2048; PERIOD=504; WRAP=0; SEARCH=pattern
elif test $rand -eq -8; then
#  Nothing found in a while
  NEIGHBORS=12; RULE=B3/S27; LENGTH=2048; PERIOD=4; WRAP=0; SEARCH=pattern
elif test $rand -eq -9; then
  NEIGHBORS=12; RULE=B3/S278; LENGTH=2048; PERIOD=12; WRAP=0; SEARCH=pattern
elif test $rand -eq -10; then
#  May not be GL and no glider
  NEIGHBORS=12; RULE=B4/S345; LENGTH=2048; PERIOD=36; WRAP=1; SEARCH=glider
elif test $rand -eq -11; then
#  Nothing found in a while
  NEIGHBORS=12; RULE=B4/S35; LENGTH=1024; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -12; then
  NEIGHBORS=12; RULE=B45/S34; LENGTH=1024; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -13; then
#  long to settle and lots of junk
  NEIGHBORS=12; RULE=B456/S12; LENGTH=2048; PERIOD=240; WRAP=0; SEARCH=pattern
elif test $rand -eq -14; then
#  Nothing found in a while
  NEIGHBORS=12; RULE=B456/S34; LENGTH=1024; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -15; then
  NEIGHBORS=12; RULE=B46/S246; LENGTH=2048; PERIOD=840; WRAP=0; SEARCH=pattern
elif test $rand -eq -16; then
  NEIGHBORS=12; RULE=B46/S35; LENGTH=1024; PERIOD=12; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -17; then
  NEIGHBORS=12; RULE=B46/S356; LENGTH=1024; PERIOD=24; WRAP=$WRAPLESS; SEARCH=pattern
elif test $rand -eq -18; then
  NEIGHBORS=8; RULE=B5/S678; LENGTH=2048; PERIOD=840; WRAP=$WRAPLESS; SEARCH=pattern
    STATES=4; FILL=55 #really simulates 17 neighbors
fi

echo "$rand: ${NEIGHBORS}${RULE}"
if test "$STATES" != 2; then
  NEIGHBORSTRING="${STATES}N${NEIGHBORS}"
else
  NEIGHBORSTRING="${NEIGHBORS}"
fi
sleep 5
RULESTRIP=`echo $RULE | sed s:/::`
for i in $(seq 1 $THREADS); do
  a=`expr 96 + $i | awk '{ printf("%c",$0); }'`
  if test "$HEADLESS" = "1"; then
    CMD="-classpath classes com/sillycycle/bagleyd/life2d/Life2D"
  else
    CMD="-jar Life2DApp.jar"
  fi
  CMD="nohup java -server $CMD\
 -states=$STATES -neighbors=$NEIGHBORS -rule=$RULE\
 -searchCount=$COUNT -excludePeriod=$PERIOD -stirs=$STIRS -wrap=$WRAP\
 -searchLength=$LENGTH -visible=0 -${SEARCH}Search=1 -delay=0\
 -edgeDetection=$EDGE -unboundDetection=$UNBOUND -blobPercent=$BLOB\
 -fillPercent=$FILL -numberedSearch=$NUMBERED\
 -windowWidth=0 -windowHeight=0 -windowX=256 -windowY=0"
  #echo $CMD 
  $CMD > data${NEIGHBORSTRING}${RULESTRIP}_${a}.life 2>&1 &
  if test "$HEADLESS" = "1"; then
    echo $!
  fi
  sleep 4
done

sleep 5
ls -alrt data?*.life
bin/lifecheck.sh
