#!/bin/sh

pwd=`pwd`
dir=`basename $pwd`
if test "$1" = "-k"; then
  ps -ef | grep $dir/Life | grep -v grep | awk '{print $2}' | xargs kill -9
fi

ls data?*.life > /dev/null 2>&1
if test $? = 0; then
  SUBTOTAL=0
  for d in data?*.life; do
    COUNT=`grep Dim $d | wc -l`
    SUBTOTAL=`expr $SUBTOTAL + $COUNT`
    if test $COUNT -gt 0; then
      echo "  $d: $COUNT"
      cp $d data.life
    elif grep "junk" $d | grep ".sig"; then
      echo $d
    else
      LINES=`wc -l $d | awk '{print $1;}'`
      if test $? -ne 0; then
        if test $LINES -gt 0; then
          echo "  warning $d: $LINES"
        fi
      fi
    fi
    STRING="FIXME"
    WC=`grep "$STRING" $d | wc -l`
    if test $WC -ne 0; then
      echo "$STRING: $WC"
    fi
    STRING="found"
    WC=`grep "$STRING" $d | wc -l`
    if test $WC -ne 0; then
      echo "$STRING: $WC"
    fi
    STRING="Edge hit"
    WC=`grep "$STRING" $d | wc -l`
    if test $WC -ne 0; then
      echo "$STRING: $WC"
    fi
    STRING="Possibly unbounded"
    WC=`grep "$STRING" $d | wc -l`
    if test $WC -ne 0; then
      echo "$STRING: $WC"
    fi
  done
  if test $SUBTOTAL != 0; then
    echo " $dir: $SUBTOTAL"
  fi
fi
