package com.sillycycle.bagleyd.life2d;

/* Code here is mostly due to Alex Shvets */
/* http://home.comcast.net/~shvets/Programs/Examples/GameLife/life2.html */

// Life2DSelection.java

import java.io.IOException;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;

public class Life2DSelection implements Transferable {

	public static final DataFlavor lifeFlavor =
		new DataFlavor(Life2DMatrix.class, "Life matrix");

	private final Life2DMatrix data;

	public Life2DSelection(Life2DMatrix data) {
		this.data = data;
	}

	// implements Transferable

	// supported flavors
	@Override
	public synchronized DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[]{ lifeFlavor };
	}

	@Override
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return (flavor.isMimeTypeEqual(Life2DSelection.lifeFlavor));
	}

	@Override
	public synchronized Object getTransferData(DataFlavor flavor)
			throws UnsupportedFlavorException, IOException {
		if (flavor.isMimeTypeEqual(Life2DSelection.lifeFlavor))
			return data;
		throw new UnsupportedFlavorException(flavor);
	}
}
